#import <Cocoa/Cocoa.h>
#import <Sc21/Sc21.h>
#include <Inventor/nodes/SoNodes.h>
#include <Inventor/sensors/SoTimerSensor.h>
#include <Inventor/events/SoKeyboardEvent.h>
#include <Inventor/events/SoMouseButtonEvent.h>

//Macintosh-specific stuff

@interface AppController : NSObject {
  IBOutlet SCSceneGraph * scenegraph;
  IBOutlet SCExaminerHandler * examiner;
  IBOutlet SCController * controller;
  IBOutlet SCView * view;
}

- (IBAction)key:(id)sender;
- (IBAction)quit:(id)sender;
- (IBAction)setup:(id)sender;
- (IBAction)startstop:(id)sender;
@end

//our specific stuff

#define FPS 30.
#define FPSInterval 1./FPS

#define MAX_X 5
#define MAX_Y 5
#define MAX_Z 1

#define RANDOM 0
#define RANDOMINTERVAL 5

#define BOXES_SEPARATION 0
#define BOXES_THICKNESS 1
#define INITIAL_HEIGHT 1.

#define FORCE_FEEDBACK 0
#define COMPRESSION .1

#define STRESS 1
#define DENSITY 1
#define WAVESPEED_2 STRESS/DENSITY

void destruct();
void init();
void keyevent(char key);
void idle(void * data, SoSensor * sensor);
void updatescene();

char running=0;
//The root-Node
SoSeparator * root=NULL;
NSEvent * keyboardevent=NULL;
SoTimerSensor * timer=NULL;
float t=0;
int counter;

typedef struct _cubestype{
	SoSeparator * sep;
	SoTranslation * tran;
	SoCube * cube;
	float h;
	float b;
	float c;
} cubestype;

cubestype cubes[MAX_X][MAX_Y][MAX_Z+1];
float heightbuffer[MAX_X][MAX_Y][MAX_Z+1];
float heightbuffer2[MAX_X][MAX_Y][MAX_Z+1];
