//Drum.cpp
//Created by Lukas Fuellemann and Tobais Stamm
//The implementation-file of the drum


#include "Drum.h"
#include "Globals.h"
#include "Wall.h"
#include <Inventor/nodes/SoNodes.h>

float DrumMaterialDiffuseColor[]={.4,.4,.4};
float DrumMaterialSpecularColor[]={0,0,.4};
float DrumMaterialShininess=.1;
float DrumMaterialTransparency=.7;

//Constructor
Drum::Drum(float size){
	//create a new separator
	sep=new SoSeparator();
	
	//create the rotation and add it to the separator
	tran=new SoTransform();
	sep->addChild(tran);
	
	//create the material of all walls
	mat=new SoMaterial();
	mat->diffuseColor.setValue(DrumMaterialDiffuseColor);
	mat->specularColor.setValue(DrumMaterialSpecularColor);
	mat->shininess=DrumMaterialShininess;
	mat->transparency=DrumMaterialTransparency;

	//create all 6 walls
	wall[0]=new Wall(mat, 0, 0, size, size*2, size*2, .01);
	wall[1]=new Wall(mat, 0, 0, -size, size*2, size*2, .01);
	wall[2]=new Wall(mat, 0, size, 0, size*2 , .01, size*2);
	wall[3]=new Wall(mat, 0, -size, 0, size*2, .01, size*2);
	wall[4]=new Wall(mat, size, 0, 0, .01, size*2, size*2);
	wall[5]=new Wall(mat, -size, 0, 0, .01, size*2, size*2);

	//add all walls to the separator
	for(int i=0;i<6;i++){
		sep->addChild(wall[i]->getSep());
	}
}

//Destructor
Drum::~Drum(){
	//nothing to do. Elements will be deleted by root->unref
}