//Constants.h
//Created by Lukas Fuellemann and Tobais Stamm
//The constants and configration of the Program

#ifndef GLOBALS_INCLUDED
#define GLOBALS_INCLUDED

class SbVec3f;

#ifndef NULL
//another NULL-Value
#define NULL 0
#endif //NULL

//The Framerate in frames per second
#define FPS 60.
#define FPSInterval 1./FPS
//Pi
#define PI 3.14159
//Gravity
#define GRAVITY 9.81

//////////////////
// Tuning

//how many spheres are in the drum
#define MAX_SPHERES 1000
//how many spheres are in the drum
#define START_NUM_SPHERES 1
//How much is the radius randomized
#define RANDOMIZE_FACTOR .5
//Which is the maximum initial size of a sphere
#define MAX_RADIUS .15
//the size of the drum (radius)
#define DRUM_RADIUS 2.
//The damping-factor of the walls
#define WALL_DAMPING .2
//The bumping-factor of the walls
#define WALL_BUMPING (DRUM_RADIUS*250.)
//The starting velocity
#define INIT_VELOCITY 3.
//Water-Elements
#define MAX_WATER_X 100
#define MAX_WATER_Y 100
//Water-Height
#define WATER_LEVEL (DRUM_RADIUS/3)
#define WATER_HEIGHT (-DRUM_RADIUS+WATER_LEVEL)
#define WATER_WAVESIZE .9
#define WATER_SPHERE_DAMPING .01
//Speed of the waves
#define WAVE_SPEED (MAX_WATER_X*MAX_WATER_Y/7)
#define WATER_SIZE (2.828*DRUM_RADIUS)
#define SPHERE_DROP (FPSInterval*MAX_RADIUS*MAX_WATER_X*MAX_WATER_Y)
//particles
#define MAX_PARTICLES 2
#define PARTICLE_SIZE (DRUM_RADIUS/20)

#endif //GLOBALS_INCLUDED