//List.cpp
//Created by Lukas Fuellemann and Tobais Stamm
//The file of the list

#include "Globals.h"
#include "ListArray.h"
#include "ListElement.h"
#include "Sphere.h"

ListArray::ListArray(){
	for(int x=0;x<NOF_CELLS;x++){
		for(int y=0;y<NOF_CELLS;y++){
			for(int z=0;z<NOF_CELLS;z++){
				cells[x][y][z]=NULL;
			}		
		}
	}
}

ListArray::~ListArray(){
	CleanAll();
}

void ListArray::Add(Sphere * sphere)
{
	int l[3],u[3];
	getLowerIndexes(l,sphere);
	getUpperIndexes(u,sphere);
	for(int x=l[0];x<=u[0];x++){
		for(int y=l[1];y<=u[1];y++){
			for(int z=l[2];z<=u[2];z++){
				ListElement * elem = new ListElement(sphere);
				elem->setNext(cells[x][y][z]);
				cells[x][y][z]=elem;
			}		
		}
	}
}

void ListArray::Traverse(Sphere * sphere, void(*callback)(Sphere * sphere1, Sphere * sphere2)){
	int l[3],u[3];
	getLowerIndexes(l,sphere);
	getUpperIndexes(u,sphere);
	for(int x=l[0];x<=u[0];x++){
		for(int y=l[1];y<=u[1];y++){
			for(int z=l[2];z<=u[2];z++){
				ListElement* cur=cells[x][y][z];
				while(cur&&(cur->getSphere()!=sphere)){
					callback(sphere, cur->getSphere());
					cur=cur->getNext();
				}
			}		
		}
	}
}

void ListArray::getLowerIndexes(int* u, Sphere * sphere){
	u[0]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Minx())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
	u[1]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Miny())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
	u[2]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Minz())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
}
void ListArray::getUpperIndexes(int* u, Sphere * sphere){
	u[0]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Maxx())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
	u[1]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Maxy())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
	u[2]=(int)(((sqrt(2)*DRUM_RADIUS)+sphere->Maxz())/(2*sqrt(2)*DRUM_RADIUS)*NOF_CELLS);
}

void ListArray::CleanAll(){
	for(int x=0;x<NOF_CELLS;x++){
		for(int y=0;y<NOF_CELLS;y++){
			for(int z=0;z<NOF_CELLS;z++){
				if(cells[x][y][z]){delete cells[x][y][z];cells[x][y][z]=NULL;}
			}		
		}
	}
}