//Wall.cpp
//Created by Lukas Fuellemann and Tobais Stamm
//The implementation-file of the wall

#include "Wall.h"
#include <Inventor/nodes/SoNodes.h>

//Constructor
Wall::Wall(SoMaterial* mat, float tx, float ty, float tz, float w, float h, float d){
	//Create a new Separator
	sep=new SoSeparator();

	//create a new Translation
	tran=new SoTransform();
	tran->translation.setValue(tx,ty,tz);
	
	//create the cube
	cube=new SoCube();
	cube->width.setValue(w);
	cube->height.setValue(h);
	cube->depth.setValue(d);
	
	//put them together
	sep->addChild(tran);
	sep->addChild(mat);
	sep->addChild(cube);
}

//Destructor
Wall::~Wall(){
	//nothing to do. Elements will be deleted by root->unref
}
